#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef unsigned int ins_t;

#define AFFECTE    1
#define AFFECTEP   2
#define SI         3
#define SAUT       4
#define CPILE      5
#define DPILE      6
#define APPEL      7
#define RETOUR     8
#define TEST       9
#define TRAPPE    10
#define AFFECTESP 11

#define DONNEES  255

#define CLONE     1
#define RECOUVRE  2
#define ATTENDS   3
#define FIN       4
#define CAPTURE   5
#define EMETS     6
#define ID        7
#define IDP       8
#define LIT       9
#define ECRIT    10

#define SET_INDIRECT(v)     ( (v) |=  0x01 )
#define SET_PILE(v)         ( (v) |=  0x02 )
#define SET_NOTCONSTANT(v)  ( (v) |=  0x04 )

#define SET_INS(i,v)   ( (i) = ((v)<<24) | ((i)&0x003FFFFF) )
#define SET_TYPE1(i,t) ( (i) = ((t)<<19) | ((i)&0xFFC7FFFF) )
#define SET_TYPE2(i,t) ( (i) = ((t)<<16) | ((i)&0xFFF8FFFF) )
#define SET_PAR1(i,v)  ( (i) = ((v)<<8)  | ((i)&0xFFFF00FF) )
#define SET_PAR2(i,v)  ( (i) = ((v)<<0)  | ((i)&0xFFFFFF00) )

#define GET_INS(v) ( (v)>>24 )
#define GET_TYPE1(v) ( ( (v) >> 19 ) & 0x7 )
#define GET_TYPE2(v) ( ( (v) >> 16 ) & 0x7 )
#define GET_PAR1(v) ( ( (v)>>8 ) & 0xFF )
#define GET_PAR2(v) ( ( (v)>>0 ) & 0xFF )
